Whamcloud - gitweb
LU-4839 tests: wait for copytool start sanity-hsm/60
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
index 97fc46e..c2c84ef 100755 (executable)
@@ -11,10 +11,8 @@ SRCDIR=$(dirname $0)
 export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/utils:$PATH:/sbin:/usr/sbin
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test:    3815
+# bug number for skipped test:    LU-3815
 ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 34 35 36"
-# bug number for skipped test:4178         4176
-ALWAYS_EXCEPT="$ALWAYS_EXCEPT 200 221 223b 31a"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
@@ -26,7 +24,6 @@ init_logging
 
 MULTIOP=${MULTIOP:-multiop}
 OPENFILE=${OPENFILE:-openfile}
-MCREATE=${MCREATE:-mcreate}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
@@ -103,6 +100,9 @@ init_agt_vars() {
 
        # archive is purged at copytool setup
        HSM_ARCHIVE_PURGE=true
+
+       # Don't allow copytool error upon start/setup
+       HSMTOOL_NOERROR=false
 }
 
 # Get the backend root path for the given agent facet.
@@ -128,7 +128,7 @@ get_mdt_devices() {
                local idx=$(($mdtno - 1))
                MDT[$idx]=$($LCTL get_param -n \
                        mdc.$FSNAME-MDT000${idx}-mdc-*.mds_server_uuid |
-                       awk '{gsub(/_UUID/,""); print $1}' | head -1)
+                       awk '{gsub(/_UUID/,""); print $1}' | head -n1)
        done
 }
 
@@ -159,19 +159,25 @@ copytool_monitor_setup() {
        cmd="cat $test_dir/fifo > $test_dir/events &"
        cmd+=" echo \\\$! > $test_dir/monitor_pid"
 
-       # This is required for pdsh -Rmrsh and its handling of remote shells.
-       # Regular ssh and pdsh -Rssh work fine without this backgrounded
-       # subshell nonsense.
-       (do_node $agent "$cmd") &
-       export HSMTOOL_MONITOR_PDSH=$!
+       if [[ $PDSH == *Rmrsh* ]]; then
+               # This is required for pdsh -Rmrsh and its handling of remote
+               # shells.
+               # Regular ssh and pdsh -Rssh work fine without this
+               # backgrounded subshell nonsense.
+               (do_node $agent "$cmd") &
+               export HSMTOOL_MONITOR_PDSH=$!
 
-       # Slightly racy, but just making a best-effort to catch obvious
-       # problems. If we get rid of the ridiculous backgrounded subshell,
-       # this check will need to be updated to just look at the returncode
-       # of do_node.
-       sleep 1
-       ps -p $HSMTOOL_MONITOR_PDSH >&- ||
-               error "Failed to start copytool monitor on $agent"
+               # Slightly racy, but just making a best-effort to catch obvious
+               # problems.
+               sleep 1
+               ps -p $HSMTOOL_MONITOR_PDSH >&- ||
+                       error "Failed to start copytool monitor on $agent"
+       else
+               do_node $agent "$cmd"
+               if [ $? != 0 ]; then
+                       error "Failed to start copytool monitor on $agent"
+               fi
+       fi
 }
 
 copytool_monitor_cleanup() {
@@ -204,7 +210,7 @@ copytool_setup() {
 
        if [[ -z "$arc_id" ]] &&
                do_facet $facet "pkill -CONT -x $HSMTOOL_BASE"; then
-                       echo "Wakeup copytool $facet on $agent"
+                       echo "Only wakeup running copytool $facet on $agent"
                        return 0
        fi
 
@@ -231,8 +237,13 @@ copytool_setup() {
        [[ -z "$TESTNAME" ]] || prefix=$prefix.$TESTNAME
        local copytool_log=$prefix.copytool${arc_id}_log.$agent.log
 
-       do_facet $facet "$cmd < /dev/null > $copytool_log 2>&1" ||
-               error "start copytool $facet on $agent failed"
+       do_facet $facet "$cmd < /dev/null > $copytool_log 2>&1"
+       if [[ $? !=  0 ]]; then
+               [[ $HSMTOOL_NOERROR == true ]] ||
+                       error "start copytool $facet on $agent failed"
+               echo "start copytool $facet on $agent failed"
+       fi
+
        trap cleanup EXIT
 }
 
@@ -249,15 +260,32 @@ get_copytool_event_log() {
 
 copytool_cleanup() {
        trap - EXIT
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+       local facet=$SINGLEAGT
+       local agents=${1:-$(facet_active_host $facet)}
        local mdtno
        local idx
        local oldstate
        local mdt_hsmctrl
+       local hsm_root=$(copytool_device $facet)
+       local end_wait=$(( SECONDS + TIMEOUT ))
 
        do_nodesv $agents "pkill -INT -x $HSMTOOL_BASE" || return 0
-       sleep 1
-       echo "Copytool is stopped on $agents"
+
+       while (( SECONDS < end_wait )); do
+               sleep 2
+               do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+               if [ $? -ne 0 ]; then
+                       echo "Copytool is stopped on $agents"
+                       break
+               fi
+               echo "Copytool still running on $agents"
+       done
+       if do_nodesv $agents "pgrep -x $HSMTOOL_BASE"; then
+               error "Copytool failed to stop in ${TIMEOUT}s ..."
+       else
+               echo "Copytool has stopped in " \
+                    "$((TIMEOUT - (end_wait - SECONDS)))s."
+       fi
 
        # clean all CDTs orphans requests from previous tests
        # that would otherwise need to timeout to clear.
@@ -278,6 +306,9 @@ copytool_cleanup() {
                        "$oldstate" 20 ||
                        error "mds${mdtno} cdt state is not $oldstate"
        done
+       if do_facet $facet "df $hsm_root" >/dev/null 2>&1 ; then
+               do_facet $facet "rm -rf $hsm_root/*"
+       fi
 }
 
 copytool_suspend() {
@@ -305,7 +336,7 @@ make_archive() {
        local file=$HSM_ARCHIVE/$1
        do_facet $SINGLEAGT mkdir -p $(dirname $file)
        do_facet $SINGLEAGT dd if=/dev/urandom of=$file count=32 bs=1000000 ||
-               error "cannot create $file"
+               file_creation_failure dd $file $?
 }
 
 copy2archive() {
@@ -480,17 +511,19 @@ needclients() {
 
 path2fid() {
        $LFS path2fid $1 | tr -d '[]'
+       return ${PIPESTATUS[0]}
 }
 
 get_hsm_flags() {
        local f=$1
        local u=$2
+       local st
 
        if [[ $u == "user" ]]; then
-               local st=$($RUNAS $LFS hsm_state $f)
+               st=$($RUNAS $LFS hsm_state $f)
        else
-               local st=$($LFS hsm_state $f)
                u=root
+               st=$($LFS hsm_state $f)
        fi
 
        [[ $? == 0 ]] || error "$LFS hsm_state $f failed (run as $u)"
@@ -501,7 +534,8 @@ get_hsm_flags() {
 
 get_hsm_archive_id() {
        local f=$1
-       local st=$($LFS hsm_state $f)
+       local st
+       st=$($LFS hsm_state $f)
        [[ $? == 0 ]] || error "$LFS hsm_state $f failed"
 
        local ar=$(echo $st | grep "archive_id" | cut -f5 -d" " |
@@ -525,6 +559,15 @@ check_hsm_flags_user() {
        [[ $st == $fl ]] || error "hsm flags on $f are $st != $fl"
 }
 
+file_creation_failure() {
+       local cmd=$1
+       local f=$2
+       local err=$3
+
+       df $MOUNT $MOUNT2 >&2
+       error "cannot create $f with $cmd, status=$err"
+}
+
 copy_file() {
        local f=
 
@@ -538,20 +581,22 @@ copy_file() {
                f=${f/$DIR/$DIR2}
        fi
        rm -f $f
-       cp $1 $f || error "cannot copy $1 to $f"
+       cp $1 $f || file_creation_failure cp $f $?
+
        path2fid $f || error "cannot get fid on $f"
 }
 
 make_small() {
         local file2=${1/$DIR/$DIR2}
         dd if=/dev/urandom of=$file2 count=2 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
         path2fid $1 || error "cannot get fid on $1"
 }
 
 make_small_sync() {
        dd if=/dev/urandom of=$1 count=1 bs=1M conv=sync ||
-               error "cannot create $1"
+               file_creation_failure dd $1 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -561,14 +606,27 @@ cleanup_large_files() {
        [ $ratio -gt 50 ] && find $MOUNT -size +10M -exec rm -f {} \;
 }
 
+check_enough_free_space() {
+       local nb=$1
+       local unit=$2
+       local need=$((nb * unit /1024))
+       local free=$(df -kP $MOUNT | tail -1 | awk '{print $4}')
+       (( $need >= $free )) && return 1
+       return 0
+}
+
 make_large_for_striping() {
        local file2=${1/$DIR/$DIR2}
-       local sz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -1)
+       local sz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -n1)
 
        cleanup_large_files
 
+       check_enough_free_space 5 $sz
+       [ $? != 0 ] && return $?
+
        dd if=/dev/urandom of=$file2 count=5 bs=$sz conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -577,12 +635,16 @@ make_large_for_progress() {
 
        cleanup_large_files
 
+       check_enough_free_space 39 1000000
+       [ $? != 0 ] && return $?
+
        # big file is large enough, so copy time is > 30s
        # so copytool make 1 progress
        # size is not a multiple of 1M to avoid stripe
        # aligment
        dd if=/dev/urandom of=$file2 count=39 bs=1000000 conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -591,12 +653,15 @@ make_large_for_progress_aligned() {
 
        cleanup_large_files
 
+       check_enough_free_space 33 1048576
+       [ $? != 0 ] && return $?
+
        # big file is large enough, so copy time is > 30s
        # so copytool make 1 progress
        # size is a multiple of 1M to have stripe
        # aligment
        dd if=/dev/urandom of=$file2 count=33 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -605,9 +670,12 @@ make_large_for_cancel() {
 
        cleanup_large_files
 
+       check_enough_free_space 103 1048576
+       [ $? != 0 ] && return $?
+
        # Copy timeout is 100s. 105MB => 105s
        dd if=/dev/urandom of=$file2 count=103 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -628,7 +696,7 @@ wait_request_state() {
        local cmd="$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.actions"
        cmd+=" | awk '/'$fid'.*action='$request'/ {print \\\$13}' | cut -f2 -d="
 
-       wait_result $mds "$cmd" $state 100 ||
+       wait_result $mds "$cmd" $state 200 ||
                error "request on $fid is not $state on $mds"
 }
 
@@ -650,8 +718,10 @@ get_request_count() {
 
 wait_all_done() {
        local timeout=$1
+       local fid=$2
 
        local cmd="$LCTL get_param -n $HSM_PARAM.actions"
+       [[ -n $fid ]] && cmd+=" | grep '$fid'"
        cmd+=" | egrep 'WAITING|STARTED'"
 
        wait_result $SINGLEMDS "$cmd" "" $timeout ||
@@ -790,7 +860,7 @@ test_3() {
                error "user could not change hsm flags"
        dd if=/etc/passwd of=$f.append bs=1 count=3\
           conv=notrunc oflag=append status=noxfer ||
-               error "could not append to test file"
+               file_creation_failure dd $f.append $?
        check_hsm_flags $f.append "0x00000003"
 
        # Modify a file sets it dirty
@@ -799,7 +869,7 @@ test_3() {
                error "user could not change hsm flags"
        dd if=/dev/zero of=$f.modify bs=1 count=3\
           conv=notrunc status=noxfer ||
-               error "could not modify test file"
+               file_creation_failure dd $f.modify $?
        check_hsm_flags $f.modify "0x00000003"
 
        # Open O_TRUNC sets dirty
@@ -973,7 +1043,7 @@ test_10d() {
 }
 run_test 10d "Archive a file on the default archive id"
 
-test_11() {
+test_11a() {
        mkdir -p $DIR/$tdir
        copy2archive /etc/hosts $tdir/$tfile
        local f=$DIR/$tdir/$tfile
@@ -997,7 +1067,31 @@ test_11() {
        local AFILE=$(do_facet $SINGLEAGT ls $HSM_ARCHIVE'/*/*/*/*/*/*/'$fid) ||
                error "fid $fid not in archive $HSM_ARCHIVE"
 }
-run_test 11 "Import a file"
+run_test 11a "Import a file"
+
+test_11b() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+       $LFS hsm_archive -a $HSM_ARCHIVE_NUMBER $f ||
+               error "hsm_archive failed"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       local FILE_HASH=$(md5sum $f)
+       rm -f $f
+
+       import_file $fid $f
+
+       echo "$FILE_HASH" | md5sum -c
+
+       [[ $? -eq 0 ]] || error "Restored file differs"
+
+       copytool_cleanup
+}
+run_test 11b "Import a deleted file using its FID"
 
 test_12a() {
        # test needs a running copytool
@@ -1008,16 +1102,16 @@ test_12a() {
 
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
-       local f=$DIR2/$tdir/$tfile
+       local f2=$DIR2/$tdir/$tfile
        echo "Verifying released state: "
-       check_hsm_flags $f "0x0000000d"
+       check_hsm_flags $f2 "0x0000000d"
 
-       local fid=$(path2fid $f)
-       $LFS hsm_restore $f
+       local fid=$(path2fid $f2)
+       $LFS hsm_restore $f2
        wait_request_state $fid RESTORE SUCCEED
 
        echo "Verifying file state: "
-       check_hsm_flags $f "0x00000009"
+       check_hsm_flags $f2 "0x00000009"
 
        do_facet $SINGLEAGT diff -q $HSM_ARCHIVE/$tdir/$tfile $f
 
@@ -1061,7 +1155,10 @@ test_12c() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        $LFS setstripe -c 2 $f
-       local fid=$(make_large_for_striping $f)
+       local fid
+       fid=$(make_large_for_striping $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        local FILE_CRC=$(md5sum $f)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -1936,7 +2033,10 @@ test_26() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -1973,7 +2073,10 @@ test_27b() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -1992,7 +2095,10 @@ test_28() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -2170,7 +2276,10 @@ test_31b() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2191,7 +2300,10 @@ test_31c() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress_aligned $f)
+       local fid
+       fid=$(make_large_for_progress_aligned $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2212,11 +2324,23 @@ test_33() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
 
+       # to be sure wait_all_done will not be mislead by previous tests
+       # and ops.
+       cdt_purge
+       wait_for_grace_delay
+       # Also raise grace_delay significantly so the Canceled
+       # Restore action will stay enough long avail.
+       local old_grace=$(get_hsm_param grace_delay)
+       set_hsm_param grace_delay 100
+
        md5sum $f >/dev/null &
        local pid=$!
        wait_request_state $fid RESTORE STARTED
@@ -2229,8 +2353,29 @@ test_33() {
 
        $LFS hsm_cancel $f
 
-       wait_request_state $fid RESTORE CANCELED
-       wait_request_state $fid CANCEL SUCCEED
+       # instead of waiting+checking both Restore and Cancel ops
+       # sequentially, wait for both to be finished and then check
+       # each results.
+       wait_all_done 100 $fid
+       local rstate=$(get_request_state $fid RESTORE)
+       local cstate=$(get_request_state $fid CANCEL)
+
+       # restore orig grace_delay.
+       set_hsm_param grace_delay $old_grace
+
+       if [[ "$rstate" == "CANCELED" ]] ; then
+               [[ "$cstate" == "SUCCEED" ]] ||
+                       error "Restore state is CANCELED and Cancel state " \
+                              "is not SUCCEED but $cstate"
+               echo "Restore state is CANCELED, Cancel state is SUCCEED"
+       elif [[ "$rstate" == "SUCCEED" ]] ; then
+               [[ "$cstate" == "FAILED" ]] ||
+                       error "Restore state is SUCCEED and Cancel state " \
+                               "is not FAILED but $cstate"
+               echo "Restore state is SUCCEED, Cancel state is FAILED"
+       else
+               error "Restore state is $rstate and Cancel state is $cstate"
+       fi
 
        [ -z $killed ] ||
                error "Cannot kill process waiting for restore ($killed)"
@@ -2246,7 +2391,10 @@ test_34() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2279,7 +2427,10 @@ test_35() {
 
        local f=$DIR/$tdir/$tfile
        local f1=$DIR/$tdir/$tfile-1
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        local fid1=$(copy_file /etc/passwd $f1)
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
@@ -2315,7 +2466,10 @@ test_36() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -2369,7 +2523,7 @@ test_40() {
        done
        # force copytool to use a local/temp archive dir to ensure best
        # performance vs remote/NFS mounts used in auto-tests
-       if df --local $HSM_ARCHIVE >/dev/null 2>&1 ; then
+       if do_facet $SINGLEAGT "df --local $HSM_ARCHIVE" >/dev/null 2>&1 ; then
                copytool_setup
        else
                copytool_setup $SINGLEAGT $MOUNT $HSM_ARCHIVE_NUMBER $TMP/$tdir
@@ -2508,7 +2662,9 @@ test_56() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2619,10 +2775,10 @@ run_test 58 "Truncate a released file will trigger restore"
 
 test_60() {
        # This test validates the fix for LU-4512. Ensure that the -u
-       # option changes the progress reporting interval from the default
-       # (30 seconds) to the user-specified interval.
+       # option changes the progress reporting interval from the
+       # default (30 seconds) to the user-specified interval.
        local interval=5
-       local progress_timeout=$((interval * 3))
+       local progress_timeout=$((interval * 4))
 
        # test needs a new running copytool
        copytool_cleanup
@@ -2630,15 +2786,32 @@ test_60() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       local mdtidx=0
+       local mdt=${MDT_PREFIX}${mdtidx}
+       local mds=mds$((mdtidx + 1))
+
+       # Wait for copytool to register
+       wait_update_facet $mds \
+               "$LCTL get_param -n ${mdt}.hsm.agents | grep -o ^uuid" \
+               uuid 100 || error "coyptool failed to register with $mdt"
 
        local start_at=$(date +%s)
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
 
-       local mdtidx=0
-       local mdt=${MDT_PREFIX}${mdtidx}
-       local mds=mds$((mdtidx + 1))
+       local agent=$(facet_active_host $SINGLEAGT)
+       local prefix=$TESTLOG_PREFIX
+       [[ -z "$TESTNAME" ]] || prefix=$prefix.$TESTNAME
+       local copytool_log=$prefix.copytool_log.$agent.log
+
+
+       wait_update $agent \
+           "grep -o start.copy $copytool_log" "start copy" 100 ||
+               error "copytool failed to start"
 
        local cmd="$LCTL get_param -n ${mdt}.hsm.active_requests"
        cmd+=" | awk '/'$fid'.*action=ARCHIVE/ {print \\\$12}' | cut -f2 -d="
@@ -2682,6 +2855,13 @@ test_70() {
 
        # Just start and stop the copytool to generate events.
        cdt_clear_no_retry
+
+       # Wait for the copytool to register.
+       wait_update --verbose $(facet_active_host mds1) \
+               "$LCTL get_param -n ${MDT_PREFIX}0.hsm.agents | grep -o ^uuid" \
+               uuid 100 ||
+               error "copytool failed to register with MDT0000"
+
        copytool_cleanup
 
        local REGISTER_EVENT
@@ -2725,7 +2905,9 @@ test_71() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2907,7 +3089,14 @@ test_90() {
                fid=$(copy_file /etc/hosts $f.$i)
                echo $f.$i >> $FILELIST
        done
-       copytool_setup
+       # force copytool to use a local/temp archive dir to ensure best
+       # performance vs remote/NFS mounts used in auto-tests
+       if do_facet $SINGLEAGT "df --local $HSM_ARCHIVE" >/dev/null 2>&1 ; then
+               copytool_setup
+       else
+               local dai=$(get_hsm_param default_archive_id)
+               copytool_setup $SINGLEAGT $MOUNT $dai $TMP/$tdir
+       fi
        # to be sure wait_all_done will not be mislead by previous tests
        cdt_purge
        wait_for_grace_delay
@@ -2994,7 +3183,10 @@ test_104() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        # if cdt is on, it can serve too quickly the request
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER --data $DATA $f
@@ -3305,7 +3497,10 @@ test_200() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_large_for_cancel $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        # test with cdt on is made in test_221
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -3346,7 +3541,10 @@ test_202() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -3391,7 +3589,9 @@ test_221() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_large_for_cancel $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
 
@@ -3498,7 +3698,9 @@ test_223b() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -3558,7 +3760,9 @@ test_225() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -3761,7 +3965,9 @@ test_251() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_large_for_cancel $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        cdt_disable
        # to have a short test
@@ -3938,9 +4144,9 @@ test_402() {
        copytool_cleanup
 
        # deactivate all mdc on agent1
-       mdc_change_state $SINGLEAGT "MDT000." "deactivate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "deactivate"
 
-       copytool_setup $SINGLEAGT
+       HSMTOOL_NOERROR=true copytool_setup $SINGLEAGT
 
        check_agent_unregistered "uuid" # match any agent
 
@@ -3948,7 +4154,7 @@ test_402() {
        search_copytools $agent && error "Copytool start should have failed"
 
        # reactivate MDCs
-       mdc_change_state $SINGLEAGT "MDT000." "activate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "activate"
 }
 run_test 402 "Copytool start fails if all MDTs are inactive"
 
@@ -3962,7 +4168,7 @@ test_403() {
        local uuid=$(do_rpc_nodes $agent get_client_uuid | cut -d' ' -f2)
 
        # deactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "deactivate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "deactivate"
 
        copytool_setup
        # check the agent is registered on MDT0000, and not on MDT0001
@@ -3973,7 +4179,7 @@ test_403() {
        search_copytools $agent || error "No running copytools on $agent"
 
        # reactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "activate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "activate"
 
        # make sure the copytool is now registered to all MDTs
        check_agent_registered $uuid
@@ -3997,7 +4203,7 @@ test_404() {
        local fid1=$(make_small $dir_mdt0/$tfile)
 
        # deactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "deactivate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "deactivate"
 
        # send an HSM request for files in MDT0000
        $LFS hsm_archive $dir_mdt0/$tfile || error "lfs hsm_archive"
@@ -4007,7 +4213,7 @@ test_404() {
                echo "archive successful on mdt0"
 
        # reactivate all mdc for MDT0001
-       mdc_change_state $SINGLEAGT "MDT0001" "activate"
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "activate"
 
        copytool_cleanup
        # clean test files and directories
@@ -4015,6 +4221,69 @@ test_404() {
 }
 run_test 404 "Inactive MDT does not block requests for active MDTs"
 
+test_405() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local striped_dir=$DIR/$tdir/striped_dir
+
+       # create striped dir on all of MDTs
+       $LFS mkdir -i 0 -c $MDSCOUNT $striped_dir || error "lfs mkdir"
+
+       local fid1=$(make_small_sync $striped_dir/${tfile}_0)
+       local fid2=$(make_small_sync $striped_dir/${tfile}_1)
+       local fid3=$(make_small_sync $striped_dir/${tfile}_2)
+       local fid4=$(make_small_sync $striped_dir/${tfile}_3)
+
+       local idx1=$($LFS getstripe -M $striped_dir/${tfile}_0)
+       local idx2=$($LFS getstripe -M $striped_dir/${tfile}_1)
+       local idx3=$($LFS getstripe -M $striped_dir/${tfile}_2)
+       local idx4=$($LFS getstripe -M $striped_dir/${tfile}_3)
+
+       # check that compound requests are shunt to the rights MDTs
+       $LFS hsm_archive $striped_dir/${tfile}_0 $striped_dir/${tfile}_1  \
+                        $striped_dir/${tfile}_2 $striped_dir/${tfile}_3 ||
+               error "lfs hsm_archive"
+
+       wait_request_state $fid1 ARCHIVE SUCCEED $idx1 &&
+               echo "archive successful on $fid1"
+       wait_request_state $fid2 ARCHIVE SUCCEED $idx2 &&
+               echo "archive successful on $fid2"
+       wait_request_state $fid3 ARCHIVE SUCCEED $idx3 &&
+               echo "archive successful on $fid3"
+       wait_request_state $fid4 ARCHIVE SUCCEED $idx4 &&
+               echo "archive successful on $fid4"
+
+       $LFS hsm_release $striped_dir/${tfile}_0 || error "lfs hsm_release 1"
+       $LFS hsm_release $striped_dir/${tfile}_1 || error "lfs hsm_release 2"
+       $LFS hsm_release $striped_dir/${tfile}_2 || error "lfs hsm_release 3"
+       $LFS hsm_release $striped_dir/${tfile}_3 || error "lfs hsm_release 4"
+
+       cat $striped_dir/${tfile}_0 > /dev/null || error "cat ${tfile}_0 failed"
+       cat $striped_dir/${tfile}_1 > /dev/null || error "cat ${tfile}_1 failed"
+       cat $striped_dir/${tfile}_2 > /dev/null || error "cat ${tfile}_2 failed"
+       cat $striped_dir/${tfile}_3 > /dev/null || error "cat ${tfile}_3 failed"
+
+       copytool_cleanup
+}
+run_test 405 "archive and release under striped directory"
+
+test_500()
+{
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.92) ] &&
+               skip "HSM migrate is not supported" && return
+
+       # Stop the existing copytool
+       copytool_cleanup
+
+       test_mkdir -p $DIR/$tdir
+       llapi_hsm_test -d $DIR/$tdir || error "One llapi HSM test failed"
+}
+run_test 500 "various LLAPI HSM tests"
+
 copytool_cleanup
 
 complete $SECONDS